<template>
	<label :for="labelFor" :class="$style.label">
		<div :class="$style.inputContainer">
			<input
				:id="labelFor"
				:class="$style.input"
				type="checkbox"
				v-bind="$attrs"
				:checked="checked"
				@change="($event) => $emit('change', $event.target.checked)"
			/>
			<span :class="$style.checkbox">
				<span :class="$style.checkmark" />
			</span>
		</div>
		<div v-if="$slots.default" :class="$style.labelText">
			<slot />
		</div>
		<span v-else :class="$style.labelText" v-html="label" />
	</label>
</template>

<script>
export default {
	inheritAttrs: false,

	model: {
		prop: 'checked',
		event: 'change',
	},

	props: {
		checked: {
			type: Boolean,
			default: false,
		},

		label: {
			type: String,
			default: '',
		},

		labelFor: {
			type: String,
			required: true,
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.label {
	display: flex;
	align-items: flex-start;
	cursor: pointer;
}

.input-container {
	position: relative;
}

.input {
	position: absolute;
	top: 100%;
	left: 50%;
	z-index: 1;
	cursor: pointer;
	border: 0;
	opacity: 0 !important;
	transform: translateX(-50%) translateY(-100%);
}

.checkbox {
	position: relative;
	display: block;
	flex: 0 0 auto;
	width: 2.6rem;
	height: 2.6rem;
	margin: 0;
	border: 1px solid color('primary');
	border-radius: 50%;
}

.input:checked ~ .checkbox {
	background: color('primary');
}

.input:focus:invalid ~ .checkbox {
	background-color: color('-red-100');
	border-color: color('red');
}

.checkmark {
	position: absolute;
	top: 0.5rem;
	left: 0.85rem;
	width: 0.7rem;
	height: 1.15rem;
	border: 2px solid color('white');
	border-top: none;
	border-left: none;
	transform: rotate(45deg);
}

.input:focus:invalid ~ .checkbox .checkmark {
	display: none;
}

.labelText {
	@include use-text-style('type-100');

	margin-left: 1.6rem;
	line-height: 1.8571428571;

	@include above('medium') {
		margin-left: 2.6rem;
	}

	a {
		font-weight: 700;
	}
}
</style>
